// ėpQT؁iPŁFj

#include <stdlib.h>
#include <string.h>
#include "bintree.h"

//--- m[h̐ ---//
static BinNode *BinNodeAlloc(size_t size)
{
	BinNode *p = malloc(sizeof(BinNode));		// m[h̐
	p->ptr = malloc(size);						// f[^̐
	return p;
}

//--- m[h̔j ---//
static void BinNodeFree(BinNode *node)
{
	free(node->ptr);							// f[^̔j
	free(node);									// m[h̔j
}

//--- m[hnodẽo̒l̐ݒ ---//
static BinNode *BinNodeSet(BinNode *node, void *ptr, size_t size,
                           BinNode *left, BinNode *right)
{
	memcpy(node->ptr, ptr, size);				// f[^sizeoCgRs[
	node->size  = size;							// qm[h
	node->left  = left;							// qm[h
	node->right = right;						// Eqm[h
	return node;								// gւ̃|C^ԋp
}

//--- m[hpƂ镔؂ւdata̒T ---//
static BinNode *search(BinTree *t, BinNode *p, void *data)
{
	while (1) {
		if (!p)
			return NULL;					// Ts
		int cond = t->compar(data, p->ptr);
		if (cond == 0)
			return p;						// T
		else if (cond < 0)
			p = p->left;					// ؂T
		else
			p = p->right;					// E؂T
	}
}

//--- QTtdata̒T ---//
BinNode *BTsearch(BinTree *t, void *data)
{
	return search(t, t->root, data);
}

//--- m[hpƂ镔؂ւdatȃ} ---//
static BinNode *insert(BinTree *t, BinNode *p, void *data, size_t size)
{
	int cond;

	if (p == NULL) {									// }ʒu𔭌
		p = BinNodeAlloc(size);
		BinNodeSet(p, data, size, NULL, NULL);
		t->crnt = p;
	} else if ((cond = t->compar(data, p->ptr)) == 0)
		;												// L[͊ɑ
	else if (cond < 0)
		p->left  = insert(t, p->left, data, size);		// ̎qɒ
	else
		p->right = insert(t, p->right, data, size);		// E̎qɒ

	return p;
}

//--- QTtւsizeoCgdatam[h̑} ---//
BinNode *BTinsert(BinTree *t, void *data, size_t size)
{
	t->crnt = NULL;
	t->root = insert(t, t->root, data, size);
	return t->crnt;
}

//--- QTtdataƈvm[h폜 ---//
int BTremove(BinTree *t, void *data)
{
	BinNode *next, *temp;
	BinNode **left;
	BinNode **p = &(t->root);

	while (1) {
		int cond;
		if (*p == NULL)						// Ts
			return 0;
		else if ((cond = t->compar(data, (*p)->ptr)) == 0)
			break;							// T
		else if (cond < 0)
			p = &((*p)->left);				// ؂T
		else
			p = &((*p)->right);				// E؂T
	}
	if ((*p)->left == NULL)
		next = (*p)->right;
	else {
		left = &((*p)->left);
		while ((*left)->right != NULL)
			left = &(*left)->right;
		next = *left;
		*left = (*left)->left;
		next->left  = (*p)->left;
		next->right = (*p)->right;
	}
	temp = *p;
	*p = next;
	BinNodeFree(temp);

	return 1;
}

//--- m[hpƂ镔؂node_print֐ŕ\ ---//
static void print(const BinNode *p, void (*node_print)(const void *))
{
	if (p != NULL) {
		print(p->left, node_print);		// p̍؂\
		node_print(p->ptr);				// p\
		print(p->right, node_print);	// p̉E؂\
	}
}

//--- QTt̑Sm[hnode_print֐ŕ\ ---//
void BTprint(const BinTree *t, void (*node_print)(const void *))
{
	print(t->root, node_print);
}

//--- QTt̏ ---//
void BTinitialize(BinTree *t, int (*compare)(const void *, const void *))
{
	t->root = t->crnt = NULL;
	t->compar = compare;
}

//--- m[hpƂ镔؂̑Sm[hj ---//
static void free_tree(BinNode *p)
{
	if (p != NULL) {
		free_tree(p->left);				// p̍؂j
		free_tree(p->right);			// p̉E؂j
		free(p);						// pj
	}
}

//--- QTt̏I ---//
void BTfinalize(BinTree *t)
{
	free_tree(t->root);
	t->root = t->crnt = NULL;
}
