// ėpQT؁iQŁFj

#include <stdlib.h>
#include <string.h>
#include "bintree.h"

//--- m[h̐ ---//
static BinNode *BinNodeAlloc(size_t size)
{
	BinNode *p = malloc(sizeof(BinNode));		// m[h̐
	p->ptr = malloc(size);						// f[^̐
	return p;
}

//--- m[h̔j ---//
static void BinNodeFree(BinNode *node)
{
	free(node->ptr);							// f[^̔j
	free(node);									// m[h̔j
}

//--- m[hnodẽo̒l̐ݒ ---//
static BinNode *BinNodeSet(BinNode *node, void *ptr, size_t size,
                           BinNode *left, BinNode *right)
{
	memcpy(node->ptr, ptr, size);				// f[^sizeoCgRs[
	node->size  = size;							// qm[h
	node->left  = left;							// qm[h
	node->right = right;						// Eqm[h
	return node;								// gւ̃|C^ԋp
}

//--- QTtdata̒T ---//
BinNode *BTsearch(BinTree *t, void *data)
{
	if (t->root != NULL) {
		BinNode *p = t->root;
		t->stack_ptr = 0;

		while (1) {
			if (p != NULL) {
				int cond;

				t->stack[t->stack_ptr++] = p;			// X^bNɃvbV
				if ((cond = t->compar(data, p->ptr)) == 0) {
					t->stack_ptr--;
					return p;
				}
				p = (cond < 0) ? p->left : p->right;
			} else {
				t->stack_ptr = -1;
				return NULL;
			}
		}
	}
	return NULL;
}

//--- QTtrootƂ镔؂ŏL[isw=0j^őL[isw=1jT ---//
static BinNode *BTsearchMinMax(BinTree *t, BinNode *root, int sw)
{
	if (root == NULL)
		return NULL;
	else {
		BinNode *p = root;

		while (p != NULL) {
			t->stack[++t->stack_ptr] = p;				// X^bNɃvbV
			p = (sw == 0) ? p->left : p->right;
		}
		return t->stack[t->stack_ptr];
	}
}

//--- ̃m[hi傫L[lj̒T ---//
BinNode *BTsearchNext(BinTree *t)
{
	if (t->stack_ptr == -1)									// X^bN
		return NULL;
	else {
		BinNode *p;

		if (t->stack[t->stack_ptr]->right != NULL)			// E̎q
			p = BTsearchMinMax(t, t->stack[t->stack_ptr]->right, 0);
		else {												// E̎q͂Ȃ
			void *ptr = t->stack[t->stack_ptr]->ptr;
			while (1) {
				if (--t->stack_ptr < 0) {
					p = NULL;
					break;
				}
				if (t->compar(t->stack[t->stack_ptr]->ptr, ptr) > 0) {
					p = t->stack[t->stack_ptr];
					break;
				}
			}
		}
		return p;
	}
}

//--- Õm[hiL[lj̒T ---//
BinNode *BTsearchPrev(BinTree *t)
{
	if (t->stack_ptr == -1)								// X^bN
		return NULL;
	else {
		BinNode *p;

		if (t->stack[t->stack_ptr]->left != NULL)		// ̎q
			p = BTsearchMinMax(t, t->stack[t->stack_ptr]->left, 1);
		else {											// ̎q͂Ȃ
			void *ptr = t->stack[t->stack_ptr]->ptr;
			while (1) {
				if (--t->stack_ptr < 0) {
					p = NULL;
					break;
				}
				if (t->compar(t->stack[t->stack_ptr]->ptr, ptr) < 0) {
					p = t->stack[t->stack_ptr];
					break;
				}
			}
		}
		return p;
	}
}

//--- QTtւsizeoCgdatam[h̑} ---//
static BinNode *insert(BinTree *t, BinNode *p, void *data, size_t size)
{
	int cond;

	if (p == NULL) {									// }ʒu𔭌
		p = BinNodeAlloc(size);
		BinNodeSet(p, data, size, NULL, NULL);
		t->crnt = p;
	} else if ((cond = t->compar(data, p->ptr)) == 0)
		;												// L[͊ɑ
	else if (cond < 0)
		p->left  = insert(t, p->left, data, size);		// ̎qɒ
	else
		p->right = insert(t, p->right, data, size);		// E̎qɒ

	return p;
}

//--- QTtւdatȃ} ---//
BinNode *BTinsert(BinTree *t, void *data, size_t size)
{
	t->crnt = NULL;
	t->root = insert(t, t->root, data, size);
	return t->crnt;
}

//--- QTtdataƈvm[h폜 ---//
int BTremove(BinTree *t, void *data)
{
	BinNode *next, *temp;
	BinNode **left;
	BinNode **p = &(t->root);

	while (1) {
		int cond;
		if (*p == NULL)						// Ts
			return -1;
		else if ((cond = t->compar(data, (*p)->ptr)) == 0)
			break;							// T
		else if (cond < 0)
			p = &((*p)->left);				// ؂T
		else
			p = &((*p)->right);				// E؂T
	}
	if ((*p)->left == NULL)
		next = (*p)->right;
	else {
		left = &((*p)->left);
		while ((*left)->right != NULL)
			left = &(*left)->right;
		next = *left;
		*left = (*left)->left;
		next->left  = (*p)->left;
		next->right = (*p)->right;
	}
	temp = *p;
	*p = next;
	BinNodeFree(temp);

	return 1;
}

//--- m[hpƂ镔؂node_print֐ŕ\ ---//
static void print(const BinNode *p, void (*node_print)(const void *))
{
	if (p != NULL) {
		print(p->left, node_print);		// p̍؂\
		node_print(p->ptr);				// p\
		print(p->right, node_print);	// p̉E؂\
	}
}

//--- QTt̑Sm[hnode_print֐ŕ\ ---//
void BTprint(const BinTree *t, void (*node_print)(const void *))
{
	print(t->root, node_print);
}

//--- QTt̏ ---//
void BTinitialize(BinTree *t, int (*compare)(const void *, const void *), 
                  int size)
{
	t->root = t->crnt = NULL;
	t->compar = compare;
	t->stack_size = size;
	t->stack_ptr = -1;
	t->stack = calloc(sizeof(BinNode *), t->stack_size);
}

//--- m[hpƂ镔؂̑Sm[hj ---//
static void free_tree(BinNode *p)
{
	if (p != NULL) {
		free_tree(p->left);				// p̍؂j
		free_tree(p->right);			// p̉E؂j
		free(p);						// pj
	}
}

//--- QTt̏I ---//
void BTfinalize(BinTree *t)
{
	free(t->stack);
	free_tree(t->root);
	t->root = t->crnt = NULL;
}
